#include "bill.h"
//#define Saturday 6
//#define Sunday 0
//this definition complies to real 2001 calender.


bill::bill()
{
//	username="none"; plan=1;
 	callsRD=callsREW=callsLD=callsLEW=0;
 	minRD=minREW=minLD=minLEW=0;
 	feeRD=feeREW=feeLD=feeLEW=0;
 	amount=0;
}

void bill::readLine(char LocalOrRoaming, date staDate, time12 staTime, date endDate, time12 endTime)
{	time24 temp;
	switch (LocalOrRoaming)
	{
	case 'L':
		if ((staDate.dayofWeek()==6)||(staDate.dayofWeek()==0)||(staTime.get24h()>=19)||(staTime.get24h()<=7))
		{
			callsLEW+=1;
            //formula used: Duration=(24:00-StartTime)+(EndTime-0:00)+(DayDifference-1)
            minLEW+= (time12(11,59,PM)-staTime)+1
                     +(endTime-time12(12,0,AM))
                     +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		
		}
		else
		{
			callsLD+=1;
			minLD+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;

		}
		break;

	case 'R':
		if ((staDate.dayofWeek()==6)||(staDate.dayofWeek()==0)||(staTime.get24h()>=19)||(staTime.get24h()<=7))
		{
			callsREW+=1;
			minREW+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		}
		else
		{
			callsRD+=1;
			minRD+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		}
		break;

	}
}


void bill::report(istream& istr, ostream& ostr)
{       date staD, endD;
        time12 staT, endT;
		char lineInit;
        Cstring EEEEE;
		istr>>plan>>username;
        ostr<<"Plan: "<<plan<<"     User Name:"<<username<<endl;

	switch (plan)
	{
	case 1:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD+minLEW-150)*0.1; feeLD=(feeLD<0?0:feeLD);
                //feeLEW is not computed, because feeLEW is included in feeLD
                feeRD=(minRD+minREW)*0.25;
                //feeREW is not computed, because feeREW is included in feeRD
                amount=feeLD+feeRD+10;

                ostr<<"------------------------------------------------------------"<<endl;
                ostr<<"Plan 1 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.10/min           "<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLEW<<" Minutes:"<<minLEW<<" Rate:$0.10/min           "<<endl;
                ostr<<"Free Time for Daytime Local and Evng/Wknd Local: 150 min     "<<endl;
                ostr<<"Subtotal for Daytime local and Evng/Wknd Local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.25/min           "<<endl;
                ostr<<"Evng/Wknd Roaming: Calls:"<<callsREW<<" Minutes:"<<minREW<<" Rate:$0.25/min           "<<endl;
				ostr<<"Subtotal for Daytime Remote and Evng/Wknd Remote:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$10.00"<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<amount<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        case 2:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD-100)*0.07; feeLD=(feeLD<0?0:feeLD);
                //feeLEW is free of charge
                feeRD=(minRD+minREW)*0.15;
                //feeREW is not computed, because feeREW is included in feeRD
                amount=feeLD+feeRD+20;


                ostr<<"------------------------------------------------------------"<<endl;
                ostr<<"Plan 2 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.07/min           "<<endl;
                ostr<<"Free Time for Daytime Local: 100 min     "<<endl<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLEW<<" Minutes:"<<minLEW<<" Rate:Free!           "<<endl;
                ostr<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<"0.00"<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.15/min           "<<endl;
                ostr<<"Evng/Wknd Roaming: Calls:"<<callsREW<<" Minutes:"<<minREW<<" Rate:$0.15/min           "<<endl;
	        ostr<<"Subtotal for Daytime Roaming and Evng/Wknd Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$20.00"<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<amount<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        case 3:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD-250)*0.05; feeLD=(feeLD<0?0:feeLD);
                //feeLEW is free of charge
                feeRD=minRD*0.20;
                feeREW=minREW*0.20;

                amount=feeLD+feeRD+feeREW+35;


                ostr<<"------------------------------------------------------------"<<endl;
                ostr<<"Plan 3 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.05/min           "<<endl;
                ostr<<"Free Time for Daytime Local: 250 min     "<<endl<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLEW<<" Minutes:"<<minLEW<<" Rate:Free!           "<<endl;
                ostr<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<"0.00"<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.20/min           "<<endl;
				ostr<<"Subtotal for Daytime Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Roaming:   Calls:"<<callsREW<<" Minutes:"<<minREW<<" Rate:$0.12/min           "<<endl;
				ostr<<"Subtotal for Evng/Wknd Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeREW<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$35.00"<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<amount<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        }
}




 