#ifndef DATE_CLASS
#define DATE_CLASS

#include <iostream.h>
#include <iomanip.h>
#include "Cstring.h"
enum monthName {JAN=1, FEB, MAR, APR, MAY, JUN, JUL, AUG, SEP, OCT, NOV, DEC};
class date
{   
   public:
      date (int mm=1, int dd=1, int yyyy=1900);
			// supply date in format MM/DD/YYYY
			// preconditions: 1 <= mm <= 12,
			//                1 <= dd <= daysInMonth()

      void writeShortDate () const;
			// output the date in the format "MM/DD/YYYY"
      void writeLongDate () const;
			// output the date in the format "month day, year"

      void incrementDate(int ndays);
			// add ndays days to the date
			// precondition: 0 <= ndays <= 365

      int numberOfDays() const;
			// return the number of days into the year

      int getMonth() const;
			// return the month as integer value 1 to 12
      int getDay() const;
			// return day of the month
      int getYear() const;
			// return the year

      void setMonth(int mm);
			// update the month
			// precondition: 1 <= mm <= 12
      void setDay(int dd);
			// update the day
			// precondition: 1 <= dd <= daysInMonth()
      void setYear(int yyyy);
			// update the year
			// precondition:  if the date is February 29,
			//                yyyy must be a leap year
      int daysInMonth() const;
			// return number of days in the month
	  
      bool isLeapYear() const;
			// is the current year a leap year (true/false)
	  int dayofWeek() const;
			// return the day of week for a specific date(Sunday=0, Monday=1, 
			// Tuesday=2, Wednesday=3, Thursday=4, Friday=5, Saturday=6)
			// 01/01/1900 is Monday
	  friend istream& operator>> (istream& istr, date& d);
			// input d in the format mm/dd/yyyy. 
	  friend ostream& operator<< (ostream& ostr, const date& d);
			// output d in the format mm/dd/yyyy. 

   private:
      enum monthName {Jan = 1, Feb, Mar, Apr, May, Jun,
                      Jul, Aug, Sep, Oct, Nov, Dec};
			// private type used by date

      int month, day, year;
			// private members that specify the date

};



#endif   // DATE_CLASS
