#ifndef TIME12_CLASS
#define TIME12_CLASS

#include "D_time24.h"

// specifies clock time units
enum timeUnit {AM, PM};

// maintains clock time
class time12
{
	private:
		time24 t;
			// store time in 24-hour format

                time24 convert12To24(int h, int m, timeUnit tunit);
	      // build t from standard time
	public:
		time12(int h=12, int m=0, timeUnit tunit = AM);
			// initialize time24 data member t

		
		
		void addTime(int m);
			// add m minutes to update current time

		void readTime();
		void writeTime();
	      // I/O member functions use format HH:MM: AM (PM)

		int get24h();
		
		       
		friend istream& operator>> (istream& istr, time12& t12);
			// input t12 in the format hh:mm AM(PM). may omit the leading digit
			// if hours or minutes < 10
		friend ostream& operator<< (ostream& ostr, const time12& t12);
			// output t12 in the format hh:mm. always include two digits
			// for the minute (e.g. 11:07 AM(PM)). hours before 12 use 1 digit
			// and precede the hour by a blank (e.g. " 7:15 AM(PM)")

                friend int operator- (const time12& lhs, const time12& rhs);

};

#endif