#define Saturday 6
#define Sunday 0
//this definition complies to real 2001 calender.

#include "bill.h"

bill::bill()
{
        initialize();
}

void bill::initialize()
{
        username="none"; plan=1;
	callsRD=0;callsRE=0;callsLD=0;callsLE=0;
	minRD=0;minRE=0;minLD=0;minLE=0;
	feeRD=0;feeRE=0;feeLD=0;feeLE=0;
	f=0;
}

float bill::getf()
{
        return f;
}

void bill::readLine(char localOrRemote, date staDate, time12 staTime, date endDate, time12 endTime)
{
	switch (localOrRemote)
	{
	case 'L':
		if ((staDate.numberOfDays()%7==Saturday)||(staDate.numberOfDays()%7==Sunday)||(staTime.get24h()>=19)||(staTime.get24h()<=7))
		{
			callsLE+=1;
                        //formula used: TimeElapsed=(24:00-StartTime)+(EndTime-0:00)+(DayDifference-1)
                        minLE+= (time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		}
		else
		{
			callsLD+=1;
			minLD+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;

		}
		break;

	case 'R':
		if ((staDate.numberOfDays()%7==Saturday)||(staDate.numberOfDays()%7==Saturday)||(staTime.get24h()>=19)||(staTime.get24h()<=7))
		{
			callsRE+=1;
			minRE+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		}
		else
		{
			callsRD+=1;
			minRD+=(time12(11,59,PM)-staTime)+1
                                +(endTime-time12(12,0,AM))
                                +((endDate.numberOfDays()-staDate.numberOfDays()-1)*1440) ;
		}
		break;

	}
}


void bill::report(istream& istr, ostream& ostr)
{       date staD, endD;
        time12 staT, endT;
	char lineInit;
        Cstring EEEEE;
	istr>>plan>>username;
        ostr<<"Plan: "<<plan<<"     User Name:"<<username<<endl;
        ostr.setf(ios::right);
	switch (plan)
	{
	case 1:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD+minLE-150)*0.1; feeLD=(feeLD<0?0:feeLD);
                //feeLE is not computed, because feeLE is included in feeLD
                feeRD=(minRD+minRE)*0.25;
                //feeRE is not computed, because feeRE is included in feeRD
                f=feeLD+feeRD+10;

                ostr<<"------------------------------------------------------------"<<endl;

                ostr<<"Plan 1 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.10/min           "<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLE<<" Minutes:"<<minLE<<" Rate:$0.10/min           "<<endl;
                ostr<<"Free Time for Daytime Local and Evng/Wknd Local: 150 min     "<<endl;
                ostr<<"Subtotal for Daytime local and Evng/Wknd Local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.25/min           "<<endl;
                ostr<<"Evng/Wknd Roaming: Calls:"<<callsRE<<" Minutes:"<<minRE<<" Rate:$0.25/min           "<<endl;
	        ostr<<"Subtotal for Daytime Remote and Evng/Wknd Remote:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);

                ostr<<"$"<<setprecision(5)<<10<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<f<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        case 2:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD-100)*0.07; feeLD=(feeLD<0?0:feeLD);
                //feeLE is free of charge
                feeRD=(minRD+minRE)*0.15;
                //feeRE is not computed, because feeRE is included in feeRD
                f=feeLD+feeRD+20;


                ostr<<"------------------------------------------------------------"<<endl;
                ostr<<"Plan 2 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.07/min           "<<endl;
                ostr<<"Free Time for Daytime Local: 100 min     "<<endl<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLE<<" Minutes:"<<minLE<<" Rate:Free!           "<<endl;
                ostr<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<"0.00"<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.15/min           "<<endl;
                ostr<<"Evng/Wknd Roaming: Calls:"<<callsRE<<" Minutes:"<<minRE<<" Rate:$0.15/min           "<<endl;
	        ostr<<"Subtotal for Daytime Roaming and Evng/Wknd Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<setprecision(5)<<20<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<f<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        case 3:
                istr>>lineInit;
                while (lineInit!='E')
                {
                    istr>>staD>>staT>>endD>>endT;
                    readLine(lineInit,staD,staT,endD,endT);
                    ostr<<lineInit<<"     "<<staD<<"     "<<staT<<"     "<<endD<<"     "<<endT<<endl;
                    istr>>lineInit;
                }
                feeLD=(minLD-250)*0.05; feeLD=(feeLD<0?0:feeLD);
                //feeLE is free of charge
                feeRD=minRD*0.20;
                feeRE=minRE*0.20;

                f=feeLD+feeRD+feeRE+35;


                ostr<<"------------------------------------------------------------"<<endl;
                ostr<<"Plan 3 Summary for User "<<username<<":     "<<endl<<endl;
                ostr<<"Daytime Local:   Calls:"<<callsLD<<" Minutes:"<<minLD<<" Rate:$0.05/min           "<<endl;
                ostr<<"Free Time for Daytime Local: 250 min     "<<endl<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeLD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Local: Calls:"<<callsLE<<" Minutes:"<<minLE<<" Rate:Free!           "<<endl;
                ostr<<"Subtotal for Daytime local:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<"0.00"<<endl;

                ostr<<endl;
                ostr<<"Daytime Roaming:   Calls:"<<callsRD<<" Minutes:"<<minRD<<" Rate:$0.20/min           "<<endl;
	        ostr<<"Subtotal for Daytime Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRD<<endl;

                ostr<<endl;
                ostr<<"Evng/Wknd Roaming:   Calls:"<<callsRE<<" Minutes:"<<minRE<<" Rate:$0.12/min           "<<endl;
	        ostr<<"Subtotal for Evng/Wknd Roaming:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<feeRE<<endl;

                ostr<<endl;
                ostr<<"Monthly Fee: "<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<setprecision(5)<<35<<endl;

                ostr<<"Grand Total:"<<endl;
                ostr.width(50);
                ostr.fill('.');
                ostr.setf(ios::right,ios::adjustfield);
                ostr<<"$"<<f<<endl;

                istr>>EEEEE;
                ostr<<EEEEE<<endl;
                break;

        }
}




 