//CSE124C Section 4 Lab2: The Yahtzee Game Feb 14 by Haibei Zhang
//hand.cpp

#include "hand.h"

//Constructor
hand::hand()
{
	rollAll();
}

//Roll (randomly) all five dice
void hand::rollAll()
{
	int i;
	for(i=0;i<5;i++)
		d[i].roll();
}

//Roll (randomly) only 1 specified(n) die (0<=n<=4)
void hand::rollOne(int n)
{
	if (n>=0 && n<5)
		d[n].roll();
}

//Set the values of all 5 dice with specified values
void hand::setHand(int v1, int v2, int v3, int v4, int v5)
{
	d[0].setDie(v1);
	d[1].setDie(v2);
	d[2].setDie(v3);
	d[3].setDie(v4);
	d[4].setDie(v5);
}

//Sort all 5 dice in ascendent order
void hand::sort()
{
	int smallIndex,temp;
	int i,j;
	for(i=0;i<4;i++)
	{
		smallIndex=i;
		for(j=i+1;j<5;j++)
			if(d[j].getDie()<d[smallIndex].getDie())
				smallIndex=j;
		temp=d[i].getDie();
		d[i].setDie(d[smallIndex].getDie());
		d[smallIndex].setDie(temp);
	}

}

//Return the score of ACES, return 0 if not applied
int hand::aces()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==1?1:0);
	return value;
}

//Return the score of TWOS, return 0 if not applied
int hand::twos()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==2?2:0);
	return value;
}

//Return the score of THREES, return 0 if not applied
int hand::threes()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==3?3:0);
	return value;
}

//Return the score of FOURS, return 0 if not applied
int hand::fours()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==4?4:0);
	return value;
}

//Return the score of FIVES, return 0 if not applied
int hand::fives()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==5?5:0);
	return value;
}

//Return the score of SIXES, return 0 if not applied
int hand::sixes()
{
	int value=0;
	int i;
	for(i=0;i<5;i++)
		value+=(d[i].getDie()==6?6:0);
	return value;
}

//Return the score of THREE OF A KIND, return 0 if not applied
int hand::threeOfAKind()
{
	sort();
	if(
		((d[0].getDie()==d[1].getDie())&&(d[1].getDie()==d[2].getDie()))
		||
		((d[1].getDie()==d[2].getDie())&&(d[2].getDie()==d[3].getDie()))
		||
		((d[2].getDie()==d[3].getDie())&&(d[3].getDie()==d[4].getDie()))
		)
		return d[0].getDie()+d[1].getDie()+d[2].getDie()+d[3].getDie()+d[4].getDie();
	else
		return 0;
}

//Return the score of FOUR OF A KIND, return 0 if not applied
int hand::fourOfAKind()
{
	sort();
	if(
		((d[0].getDie()==d[1].getDie())&&(d[1].getDie()==d[2].getDie())&&(d[2].getDie()==d[3].getDie()))
		||
		((d[1].getDie()==d[2].getDie())&&(d[2].getDie()==d[3].getDie())&&(d[3].getDie()==d[4].getDie()))
		)
		return d[0].getDie()+d[1].getDie()+d[2].getDie()+d[3].getDie()+d[4].getDie();
	else
		return 0;
}

//Return the score of FULL HOUSE, return 0 if not applied
int hand::fullHouse()
{
	sort();
	if(
		((d[0].getDie()==d[1].getDie())&&(d[1].getDie()==d[2].getDie())&&(d[3].getDie()==d[4].getDie()))
		||
		((d[0].getDie()==d[1].getDie())&&(d[2].getDie()==d[3].getDie())&&(d[3].getDie()==d[4].getDie()))
		)
		return 25;
	else
		return 0;
}

//Return the score of SMALL STRAIGHT, return 0 if not applied
int hand::smStraight()
{
	sort();
	int gap=0;
	int i;
	for (i=0;i<4;i++)
	{
		if(d[i+1].getDie()-d[i].getDie()<=1)
		{
			gap+=d[i+1].getDie()-d[i].getDie();
			if(gap>=3)
				return 30;
		}
		else
			gap=0;
	}

	return 0;
}

//Return the score of LARGE STRAIGHT, return 0 if not applied
int hand::lgStraight()
{
	sort();
	int gap=0;
	int i;
	for (i=0;i<4;i++)
		if(d[i+1].getDie()-d[i].getDie()==1)
			gap++;
	if(gap==4)
		return 40;
	else 
		return 0;
}

//Return the score of YAHTZEE, return 0 if not applied
int hand::yahtzee()
{
	if((d[0].getDie()==d[1].getDie())&&(d[1].getDie()==d[2].getDie())&&(d[2].getDie()==d[3].getDie())&&(d[3].getDie()==d[4].getDie()))
		return 50;
	else
		return 0;
}

//Return the sum of all 5 dice
int hand::chance()
{
	return d[0].getDie()+d[1].getDie()+d[2].getDie()+d[3].getDie()+d[4].getDie();
}

//Print the values of all 5 dice to screen
void hand::printHand()
{
	int i;
	for(i=0;i<5;i++)
		cout<<"   |   "<<d[i].getDie();
	cout<<"   |"<<endl;
}
