//CSE124C Lab2 Section 4: The Yahtzee Game Feb 14 by Haibei Zhang
//test.cpp
//The PLAYER and COMPUTERPLAYER classes are to be tested by playing real games (main.cpp)
//This is for testing. To run this program, remove "main.cpp" from this Workspace before execution.


#include <time.h>
#include "hand.h"
#include "card.h"


int main()
{
	//Ensure that rand() funtion yields random numbers
	srand( (unsigned)time( NULL ) ); 
	
	//Test the DIE class
	cout<<"----------------Test die class-------------------------"<<endl;
	die testdie;

	//test the CONSTRUCTOR of DIE, expect to generate a random number
	cout<<"Test the initialization of a die object"<<endl;
	cout<<"Initialized die value:"<<endl;
	testdie.printDie();
	cout<<endl;
	
	//test the ROLL method, expect to generate a random number
	cout<<"Test roll() method, is the n value randomly generated?"<<endl;
	char choice;
	do
	{
		testdie.roll();
		cout<<"Die is rolled"<<endl;
		testdie.printDie();
		cout<<endl<<"Roll again? (y/n)"<<endl;
		cin>>choice;
	}
	while(choice=='y');

	//test the HAND class
	cout<<"--------------Test hand class--------------------------"<<endl;
	hand testhand;
	
	//test the CONSTRUCTOR of HAND, expect to generate 5 random dice
	cout<<"Test the initialization of a hand object"<<endl;
	cout<<"Initialized hand value: "<<endl;
	testhand.printHand();

	//test the ROLLALL method, expect to generate 5 random dice
	cout<<"Test rollall() method"<<endl;
	do
	{
		testhand.rollAll();
		cout<<"The whole hand is rolled"<<endl;
		testhand.printHand();
		cout<<"Roll again? (y/n)"<<endl;
		cin>>choice;
	}
	while(choice=='y');

	//test the ROLLONE method, expect to generate 1 random dice
	cout<<"Test rollOne() method"<<endl;
	int d;
	do
	{
		cout<<"Which die will you reroll? (1-5)"<<endl;
		cin>>d;
		testhand.rollOne(d-1);
		cout<<"After rerolling one die: "<<endl;
		testhand.printHand();
		cout<<"Roll again? (y/n)"<<endl;
		cin>>choice;
	}
	while(choice=='y');

	
	//Following tests are for the SORT method and every category judgement method

	//test the ACES judgement, expect to return 2
	cout<<"Test judgement of all categories"<<endl;
	testhand.setHand(1,2,1,3,4);
	testhand.printHand();
	cout<<"The score of Aces is "<<testhand.aces()<<endl<<endl;

	//test the TWOS judgement, expect to return 6
	testhand.setHand(2,1,2,3,2);
	testhand.printHand();
	cout<<"The score of Twos is "<<testhand.twos()<<endl<<endl;

	//test the THREES judgement, expect to return 6
	testhand.setHand(4,3,5,3,1);
	testhand.printHand();
	cout<<"The score of Threes is "<<testhand.threes()<<endl<<endl;

	//test the FOURS judgement, expect to return 8
	testhand.setHand(3,4,5,6,4);
	testhand.printHand();
	cout<<"The score of Fours is "<<testhand.fours()<<endl<<endl;

	//test the FIVES judgement, expect to return 5
	testhand.setHand(5,1,2,4,1);
	testhand.printHand();
	cout<<"The score of Fives is "<<testhand.fives()<<endl<<endl;

	//test the SIXES judgement, expect to return 24
	testhand.setHand(6,4,6,6,6);
	testhand.printHand();
	cout<<"The score of Sixes is "<<testhand.sixes()<<endl<<endl;

	//test the 3 OF A KIND judgement, expect to return 17
	testhand.setHand(3,6,3,2,3);
	testhand.printHand();
	cout<<"The score of 3 of a kind is "<<testhand.threeOfAKind()<<endl;

	//test the 3 OF A KIND judgement again, expect NOT to return 3 OF A KIND (0)
	testhand.setHand(2,6,4,2,1);
	testhand.printHand();
	cout<<"The score of 3 of a kind (test again) is "<<testhand.threeOfAKind()<<endl<<endl;

	//test the 4 OF A KIND judgement, expect to return 6
	testhand.setHand(1,2,1,1,1);
	testhand.printHand();
	cout<<"The score of 4 of a kind is "<<testhand.fourOfAKind()<<endl;

	//test the 4 OF A KIND judgement again, expect NOT to return 4 OF A KIND (0)
	testhand.setHand(4,5,2,5,5);
	testhand.printHand();
	cout<<"The score of 4 of a kind (test again) is "<<testhand.fourOfAKind()<<endl<<endl;

	//test the FULL HOUSE judgement, expect to return 25
	testhand.setHand(5,6,6,5,5);
	testhand.printHand();
	cout<<"The score of FULL HOUSE is "<<testhand.fullHouse()<<endl;

	//test the FULL HOUSE judgement again, expect NOT to return FULL HOUSE (0)
	testhand.setHand(3,6,3,3,1);
	testhand.printHand();
	cout<<"The score of FULL HOUSE (test again) is "<<testhand.fullHouse()<<endl<<endl;

	//test the SM STRAIGHT judgement, expect to return 30
	testhand.setHand(6,5,4,5,3);
	testhand.printHand();
	cout<<"The score of SM STRAIGHT is "<<testhand.smStraight()<<endl;

	//test the SM STRAIGHT judgement again, expect NOT to return SM STRAIGHT (0)
	testhand.setHand(1,2,3,5,6);
	testhand.printHand();
	cout<<"The score of SM STRAIGHT (test again) is "<<testhand.smStraight()<<endl<<endl;

	//test the LG STRAIGHT judgement, expect to return 40
	testhand.setHand(5,3,2,4,6);
	testhand.printHand();
	cout<<"The score of LG STRAIGHT is "<<testhand.lgStraight()<<endl;

	//test the LG STRAIGHT judgement again, expect NOT to return LG STRAIGHT (0)
	testhand.setHand(1,2,3,5,6);
	testhand.printHand();
	cout<<"The score of LG STRAIGHT (test again) is "<<testhand.lgStraight()<<endl<<endl;

	//test the YAHTZEE judgement again, expect to return 50
	testhand.setHand(5,5,5,5,5);
	testhand.printHand();
	cout<<"The score of YAHTZEE is "<<testhand.yahtzee()<<endl;

	//test the YAHTZEE judgement again, expect NOT to return YAHTZEE (0)
	testhand.setHand(3,3,4,3,3);
	testhand.printHand();
	cout<<"The score of YAHTZEE (test again) is "<<testhand.yahtzee()<<endl<<endl;

	//test the CHANCE category, expect to return 19
	testhand.setHand(4,3,2,6,4);
	testhand.printHand();
	cout<<"The score of CHANCE is "<<testhand.chance()<<endl<<endl;





	//test the CARD class
	cout<<"--------------Test card class--------------------------"<<endl;
	card testcard;

	//test the CONSTRUCTOR of CARD, expect to have -999 as each blank category
	cout<<"Test the initialization of the card object"<<endl;
	testcard.printCard();

	//test the INPUTSCORE and SETSCORE method, expect to promt user to change a score of a category
	//INPUTSCORE method is no longer used in Lab2
	cout<<"Test inputScore() and setScore()"<<endl;
	for(int j=0; j<13;j++)
	{
		testcard.inputScore(); 
		cout<<"If you input score to an occupied category, you will expect to get an error and be prompted to input again."<<endl;
	}

	//test the UPPERTOTAL, UPPERBONUS, LOWERTOTAL method
	cout<<"Test upperTotal(), upperBonus(), lowerTotal()"<<endl;
	testcard.printCard();

	
	cout<<"-----------End of Test-------------"<<endl;
	
	return 0;
}
